#ifndef _TCAPS_CI_RULE_H_
#define _TCAPS_CI_RULE_H_

//#include <string>
//
//
//class TCAPS_Rule
//{
//	
//public:
//
//  TCAPS_Rule (unsigned int rn, char * rtext, unsigned int rtimeout);
//  ~TCAPS_Rule (void);
//  
//  unsigned int get_timeout();
//  const char * get_rule_text();
//
//
//protected:
//  unsigned int rule_number;
//  unsigned int rule_timeout;
//  char * rule_text;
//
//};







class TCAPS_Rule
{
public:
	TCAPS_Rule ();
	TCAPS_Rule (const struct tcaps_sp_rmp * rule_pack);
	TCAPS_Rule (const TCAPS_Rule &);
	virtual ~TCAPS_Rule (void);

	u16 get_rule_num() const;
	const char * get_rule_text() const;
	const u8 * get_serialized() const;
	unsigned int get_serialized_bytes() const;
	unsigned int get_expiry_time() const;
	const struct tcaps_sp_rmp * get_rmp() const;
	void to_string(char * buf, unsigned int bufsize) const;
	
	void set_rule_text(const char * ruletext);
	void increment_expiry_time(u16 timeout);

	
	TCAPS_Rule & operator=(const TCAPS_Rule &copied_rule);
	
	friend bool operator==(const TCAPS_Rule &r1, const TCAPS_Rule &r2);

	
  
private:
	struct tcaps_sp_rmp * rule;
	unsigned int expiry_time_secs; 
	char * rule_text;
};



#endif //_TCAPS_CI_RULE_H_
