#include "tcaps_fc.h"

TCAPS_Simple_Algo::TCAPS_Simple_Algo ()
{
	ACE_DEBUG ((LM_DEBUG, "(%P|%t) TCAPS_Simple_Algo default ctor 0x%x\n", (void *) this));
}


//TCAPS_Simple_Algo::TCAPS_Simple_Algo (const TCAPS_Simple_Algo &copied_algo)
//{
//	ACE_DEBUG ((LM_DEBUG, "(%P|%t) TCAPS_Simple_Algo copy ctor 0x%x\n", (void *) this));
//}

TCAPS_Simple_Algo::~TCAPS_Simple_Algo (void)
{
	ACE_DEBUG ((LM_DEBUG, "(%P|%t) TCAPS_Simple_Algo dtor 0x%x\n", (void *) this)); 
}

void TCAPS_Simple_Algo::classify_flow(TCAPS_Flow * flow)
{
	ACE_DEBUG ((LM_DEBUG, "(%P|%t) TCAPS_Simple_Algo: We are classifying a flow!\n"));
	
//	if(ff[TCAPS_FLOW_FEATURE_AVERAGE_PAYLOAD_SIZE_BYTES_WINDOW] > 500.0)
//		flow->set_flow_priority(0);
//	else
//		flow->set_flow_priority(255);

//	ACE_DEBUG ((LM_DEBUG, "(%P|%t) TCAPS_FLOW_FEATURE_TOTAL_NUM_BIDIR_PACKETS: %0.2f!\n", flow->get_flow_feature(TCAPS_FLOW_FEATURE_TOTAL_NUM_BIDIR_PACKETS)));
//	
//	long rand = random();
//	
//	ACE_DEBUG ((LM_DEBUG, "(%P|%t) TCAPS_Simple_Algo: rand: %d\trand%%2: %d\n", rand, rand%2));
//	
//	if(rand%2 == 0)
//		flow->set_flow_priority(0);
//	else
//		flow->set_flow_priority(255);






	if(is_quake3_flow(flow))
	{
		ACE_DEBUG ((LM_DEBUG, "(%P|%t) TCAPS_Simple_Algo: Flow has been classified as Quake 3\n"));
		flow->set_flow_priority(1);
		
		char buf[1024];
		flow->to_string(buf, sizeof(buf));
		
		if(flow->state_changed())
			printf("The following flow has been classified as Quake 3:\n%s\n\n", buf);
	}
	else if(is_voip_flow(flow))
	{
		ACE_DEBUG ((LM_DEBUG, "(%P|%t) TCAPS_Simple_Algo: Flow has been classified as VoIP\n"));
		flow->set_flow_priority(0);
		
		char buf[1024];
		flow->to_string(buf, sizeof(buf));
		
		if(flow->state_changed())
			printf("The following flow has been classified as VoIP:\n%s\n\n", buf);
		
		
		
	}
	else
	{
		ACE_DEBUG ((LM_DEBUG, "(%P|%t) TCAPS_Simple_Algo: Flow has been classified as low priority\n"));
		flow->set_flow_priority(255);
	}
	
	
	
	ACE_DEBUG ((LM_DEBUG, "(%P|%t) TCAPS_Simple_Algo: Finished classifying the flow!\n"));
}

void TCAPS_Simple_Algo::to_string(char * buf, unsigned int bufsize) const
{
	snprintf(buf, bufsize, "TCAPS_Simple_Algo\n");
}

bool TCAPS_Simple_Algo::is_quake3_flow(TCAPS_Flow * flow)
{
	unsigned int likely_q3_flow = 0;
	
	if((flow->get_flow_feature(TCAPS_FLOW_FEATURE_AVERAGE_OTHER_TO_CLIENT_PACKETS_PER_SECOND) >= 16)
		&& (flow->get_flow_feature(TCAPS_FLOW_FEATURE_AVERAGE_OTHER_TO_CLIENT_PACKETS_PER_SECOND) <= 24))
	{
		likely_q3_flow++;
	}
	
	if((flow->get_flow_feature(TCAPS_FLOW_FEATURE_25TH_PERCENTILE_OTHER_TO_CLIENT_PAYLOAD_BYTES_PER_PACKET) > 40)
		&& (flow->get_flow_feature(TCAPS_FLOW_FEATURE_MAXIMUM_OTHER_TO_CLIENT_PAYLOAD_BYTES_PER_PACKET) > (2*flow->get_flow_feature(TCAPS_FLOW_FEATURE_AVERAGE_OTHER_TO_CLIENT_PAYLOAD_BYTES_PER_PACKET))))
	{
	   likely_q3_flow++;
	}
	
	if((flow->get_flow_feature(TCAPS_FLOW_FEATURE_25TH_PERCENTILE_CLIENT_TO_OTHER_INTER_ARRIVAL_TIME_MS_PER_PACKET) > 5)
		&& (flow->get_flow_feature(TCAPS_FLOW_FEATURE_90TH_PERCENTILE_CLIENT_TO_OTHER_INTER_ARRIVAL_TIME_MS_PER_PACKET) <= 70))
	{
	   likely_q3_flow++;
	}
	
	if((flow->get_flow_feature(TCAPS_FLOW_FEATURE_25TH_PERCENTILE_CLIENT_TO_OTHER_PAYLOAD_BYTES_PER_PACKET) > 30)
		&& (flow->get_flow_feature(TCAPS_FLOW_FEATURE_90TH_PERCENTILE_CLIENT_TO_OTHER_PAYLOAD_BYTES_PER_PACKET) <= 90))
	{
	   likely_q3_flow++;
	}
	
	ACE_DEBUG ((LM_DEBUG, "(%P|%t) TCAPS_Simple_Algo: Flow matched %d out of 4 Quake3 rules\n", likely_q3_flow));
	
	if(likely_q3_flow > 2)
	{
		return true;
	}

	return false;
}

bool TCAPS_Simple_Algo::is_voip_flow(TCAPS_Flow * flow)
{
	unsigned int likely_voip_flow = 0;
	
	if((flow->get_flow_feature(TCAPS_FLOW_FEATURE_25TH_PERCENTILE_CLIENT_TO_OTHER_INTER_ARRIVAL_TIME_MS_PER_PACKET) > 15)
		&& (flow->get_flow_feature(TCAPS_FLOW_FEATURE_90TH_PERCENTILE_CLIENT_TO_OTHER_INTER_ARRIVAL_TIME_MS_PER_PACKET) <= 25))
	{
	   likely_voip_flow++;
	}
	
	if((flow->get_flow_feature(TCAPS_FLOW_FEATURE_25TH_PERCENTILE_CLIENT_TO_OTHER_PAYLOAD_BYTES_PER_PACKET) > 150)
		&& (flow->get_flow_feature(TCAPS_FLOW_FEATURE_90TH_PERCENTILE_CLIENT_TO_OTHER_PAYLOAD_BYTES_PER_PACKET) <= 190))
	{
	   likely_voip_flow++;
	}
	
	ACE_DEBUG ((LM_DEBUG, "(%P|%t) TCAPS_Simple_Algo: Flow matched %d out of 2 VoIP rules\n", likely_voip_flow));
	
	if(likely_voip_flow == 2)
	{
		return true;
	}

	return false;
}
	
//TCAPS_Classification_Algo & TCAPS_Classification_Algo::operator=(const TCAPS_Classification_Algo & copied_algo)
//{
//	if(this == &copied_algo)
//		return *this;
//	
//	return *this;
//}
//
//bool operator==(const TCAPS_Classification_Algo &f1, const TCAPS_Classification_Algo &f2)
//{
//	return (f1.flow_id == f2.flow_id);
//}
