#ifndef _TCAPS_FC_CLASSIFIER_TASK_H_
#define _TCAPS_FC_CLASSIFIER_TASK_H_


#include "ace/Task.h"

#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */


/* Like the thread-pool server tutorial, we'll derive from ACE_Task<>.
  Our goal here is to show off the ACE_Message_Queue and the best way
  to do that is to use one to pass data between threads.  The easiest
  way to create threads is with ACE_Task<> */
class TCAPS_Classifier_Task : public ACE_Task <ACE_MT_SYNCH>
{
public:

  typedef ACE_Task <ACE_MT_SYNCH> inherited;

  /* The constructor/destructor are simple but take care of some
    necessary housekeeping.  */
  TCAPS_Classifier_Task (TCAPS_Classification_Algo * a);
  ~TCAPS_Classifier_Task (void);

  /* open() will kick off our thread pool for us.  */
  int open (void * = 0);

  /* Our worker method */
  int svc (void);

  /* All we'll do here is print a message to the user.  */
  int close (u_long flags = 0);
  
  TCAPS_Client_List * get_clients();

protected:
  size_t n_threads_;
  TCAPS_Client_List client_list;
  TCAPS_Classification_Algo * algo;
  // Number of threads in the pool.
};





#endif //_TCAPS_FC_CLASSIFIER_TASK_H_
