#ifndef _TCAPS_FC_FLOW_ID_H_
#define _TCAPS_FC_FLOW_ID_H_





class TCAPS_Flow_ID
{
public:
	TCAPS_Flow_ID ();
	TCAPS_Flow_ID (u8 fid_type, u8 ipversion, u8 * bytes);
	TCAPS_Flow_ID (const TCAPS_Flow_ID &);
	virtual ~TCAPS_Flow_ID (void);
	
	const u8 * get_binary_flow_id() const;
	virtual void get_ascii_flow_id(char * buf) const;
	unsigned int get_num_flow_id_bytes() const;
	u8 get_flow_id_type() const;
	u8 get_flow_id_ip_version() const;
	void get_flow_id_srcip(char * buf);
	void get_flow_id_dstip(char * buf);
	
	TCAPS_Flow_ID & operator=(const TCAPS_Flow_ID &copied_fid);
	
	friend bool operator<(const TCAPS_Flow_ID &f1, const TCAPS_Flow_ID &f2);
	friend bool operator>(const TCAPS_Flow_ID &f1, const TCAPS_Flow_ID &f2);
	friend bool operator==(const TCAPS_Flow_ID &f1, const TCAPS_Flow_ID &f2);

	
  
protected:
	u8 * flow_id;
	unsigned int num_bytes;
	u8 flow_id_type;
	u8 ip_version;
  
};





#endif //_TCAPS_FC_FLOW_ID_H_
