#include "tcaps_fc.h"


TCAPS_Flow_ID_Spi::TCAPS_Flow_ID_Spi ()
{
	ACE_DEBUG ((LM_DEBUG, "(%P|%t) TCAPS_Flow_ID_Spi ctor 0x%x\n", (void *) this));
}

TCAPS_Flow_ID_Spi::TCAPS_Flow_ID_Spi (u8 fid_type, u8 ipversion, u8 * bytes)
{
	ACE_DEBUG ((LM_DEBUG, "(%P|%t) TCAPS_Flow_ID_Spi ctor 0x%x\n", (void *) this));
	
	flow_id_type = fid_type;
	ip_version = ipversion;
	
	if(TCAPS_SP_IP_VERSION_4 == ipversion)
	{
		num_bytes = (2*NUM_IPV4_OCTETS)+(2*sizeof(u32));
	}
	else if(TCAPS_SP_IP_VERSION_6 == ipversion)
	{
		num_bytes = (2*NUM_IPV6_OCTETS)+(2*sizeof(u32));
	}
	
	flow_id = (u8 *)malloc(num_bytes);
		
	memcpy(flow_id, bytes, num_bytes);
}


TCAPS_Flow_ID_Spi::TCAPS_Flow_ID_Spi (const TCAPS_Flow_ID_Spi &copied_fid)
{
	TCAPS_Flow_ID::TCAPS_Flow_ID((TCAPS_Flow_ID)copied_fid);

	src_spi = copied_fid.get_flow_id_src_spi();
	dst_spi = copied_fid.get_flow_id_dst_spi();
}

TCAPS_Flow_ID_Spi::~TCAPS_Flow_ID_Spi (void)
{
	ACE_DEBUG ((LM_DEBUG, "(%P|%t) TCAPS_Flow_ID_Spi dtor 0x%x\n", (void *) this)); 

}


TCAPS_Flow_ID_Spi & TCAPS_Flow_ID_Spi::operator=(const TCAPS_Flow_ID_Spi & copied_fid)
{
	TCAPS_Flow_ID::operator=((TCAPS_Flow_ID)copied_fid);

	src_spi = copied_fid.get_flow_id_src_spi();
	dst_spi = copied_fid.get_flow_id_dst_spi();
	
	return *this;
}

u32 TCAPS_Flow_ID_Spi::get_flow_id_src_spi() const
{
	return src_spi;
}

u32 TCAPS_Flow_ID_Spi::get_flow_id_dst_spi() const
{
	return dst_spi;
}
	

void TCAPS_Flow_ID_Spi::get_ascii_flow_id(char * buf) const
{
	ip_address temp;
	
	temp.octets = flow_id;
	temp.ip_version = ip_version;
	
	tcaps_ip_ntoa(&temp, buf, TRUE);
	
	sprintf(buf+strlen(buf), ":%u\t", *((u32*)(flow_id+(num_bytes-sizeof(u32)-sizeof(u32)))));
	
	if(TCAPS_SP_IP_VERSION_4 == ip_version)
		temp.octets = flow_id+NUM_IPV4_OCTETS;
	else
		temp.octets = flow_id+NUM_IPV6_OCTETS;
		
	tcaps_ip_ntoa(&temp, buf+strlen(buf), TRUE);

	sprintf(buf+strlen(buf), ":%u", *((u32*)(flow_id+(num_bytes-sizeof(u16)))));
}
