#ifndef _TCAPS_FS_H_
#define _TCAPS_FS_H_

#include <stdlib.h>
#include <stdio.h>
#include <pcap.h>

#include <tcaps_sp.h>

#include "ace/OS.h"
#include "ace/Signal.h"
#include "ace/SOCK_Dgram.h"

#include "tcaps_fs_packet_block.h"
#include "tcaps_fs_flow_features.h"
#include "tcaps_fs_network_task.h"
#include "tcaps_fs_flow_id.h"
#include "tcaps_fs_flow_id_port.h"
#include "tcaps_fs_flow_id_spi.h"
#include "tcaps_fs_layer4_datagram.h"
#include "tcaps_fs_tcp_datagram.h"
#include "tcaps_fs_udp_datagram.h"
#include "tcaps_fs_layer3_packet.h"
#include "tcaps_fs_ipv4_packet.h"
#include "tcaps_fs_ipv6_packet.h"
#include "tcaps_fs_layer2_frame.h"
#include "tcaps_fs_ethernet_frame.h"
#include "tcaps_fs_pcap_packet.h"
#include "tcaps_fs_flow.h"
#include "tcaps_fs_flow_list.h"
#include "tcaps_fs_client.h"
#include "tcaps_fs_client_list.h"
#include "tcaps_fs_flow_manager_task.h"
#include "tcaps_fs_sniff_task.h"


#define divideIfNotZero(N, D) ( ((D) == 0.0) ? 0.0 : ((N)/(D)) )


#define TCAPS_FLOW_TIMEOUT			10 //seconds
#define BUFFER_SIZE					1600

#define TCAPS_FS_COMMS_INTERFACE	"fxp0"
#define TCAPS_FS_SNIFF_INTERFACE	"fxp1"
#define TCAPS_TM_LOCAL_PORT			4567
#define TCAPS_FC_LOCAL_PORT			7777

#define TCAPS_FC_IP					"172.16.250.20"

//this should eventually be changed to ms
#define TCAPS_FS_SEND_STATE_TO_FC_INTERVAL_SECS 1


#undef _PACKET_PARSE_DEBUG_
//#define _PACKET_PARSE_DEBUG_

#undef _MUTEX_DEBUG_
//#define _MUTEX_DEBUG_

#endif //_TCAPS_FS_H_
