#ifndef _TCAPS_FS_CLIENT_H_
#define _TCAPS_FS_CLIENT_H_

class TCAPS_Client
{
public:
	TCAPS_Client ();
	TCAPS_Client (u8 clientip_version, u8 * clientip_octets, u8 tmip_version, u8 * tmip_octets, u8 fcip_version, u8 * fcip_octets);
	TCAPS_Client (const TCAPS_Client &copied_client);
	virtual ~TCAPS_Client (void);
	
	struct ip_address get_client_ip() const;
	struct ip_address get_tm_ip() const;
	struct ip_address get_fc_ip() const;
	TCAPS_Flow_List get_client_flows() const;
	TCAPS_Flow_List * get_client_flows();
	
	void set_fc_ip(const struct ip_address * ip);
	
	//void update_client_flow(TCAPS_Flow * flow);
	//void add_packet_to_client_flow(TCAPS_Flow * flow);
	void to_string(char * buf, unsigned int bufsize);
	
	TCAPS_Client & operator=(const TCAPS_Client &copied_client);
	
	friend bool operator<(const TCAPS_Client &f1, const TCAPS_Client &f2);
	friend bool operator>(const TCAPS_Client &f1, const TCAPS_Client &f2);
	friend bool operator==(const TCAPS_Client &f1, const TCAPS_Client &f2);

	
  
private:
	struct ip_address client_ip;
	struct ip_address tm_ip;
	struct ip_address fc_ip;
	
	TCAPS_Flow_List client_flows;
  
};

#endif //_TCAPS_FS_CLIENT_H_
