#include "tcaps_fs.h"


TCAPS_Client_List::TCAPS_Client_List ()
{
	ACE_DEBUG ((LM_DEBUG, "(%P|%t) TCAPS_Client_List default ctor 0x%x\n", (void *) this));
}


TCAPS_Client_List::TCAPS_Client_List (const TCAPS_Client_List &copied_client_list)
{
	ACE_DEBUG ((LM_DEBUG, "(%P|%t) TCAPS_Client_List copy ctor 0x%x\n", (void *) this));
	
	client_list = copied_client_list.get_client_list();
}

TCAPS_Client_List::~TCAPS_Client_List (void)
{
	ACE_DEBUG ((LM_DEBUG, "(%P|%t) TCAPS_Client_List dtor 0x%x\n", (void *) this)); 
}
	
TCAPS_Client_List & TCAPS_Client_List::operator=(const TCAPS_Client_List &copied_client_list)
{
	if(this == &copied_client_list)
		return *this;

	client_list = copied_client_list.get_client_list();
	
	return *this;
}


//std::list<TCAPS_Client> TCAPS_Client_List::get_client_list() const
//{
//	return client_list;
//}

std::map<struct ip_address,TCAPS_Client *,ipcmp> TCAPS_Client_List::get_client_list() const
{
	return client_list;
}

void TCAPS_Client_List::add_client(TCAPS_Client * theclient)
{
	client_list_mutex.acquire();
	
	//add client to the list
	
	//client_list.push_back(*theclient);
	
	client_list.insert(client_entry(theclient->get_client_ip(), theclient));

	client_list_mutex.release();
}

bool TCAPS_Client_List::find_client(struct ip_address * clientip)
{
	//std::map<struct ip_address,TCAPS_Client *,ipcmp>::iterator client_iter;
	std::map<struct ip_address,TCAPS_Client *>::iterator client_iter;
	
	client_iter = client_list.find(*clientip);
	   				 
	if (client_iter != client_list.end())
		return true;
		
	return false;
}

TCAPS_Client * TCAPS_Client_List::get_client(struct ip_address * clientip)
{
	std::map<struct ip_address,TCAPS_Client *>::iterator client_iter;
	
	client_iter = client_list.find(*clientip);
	   				 
	if (client_iter != client_list.end())
		return client_list[*clientip];
		
	return NULL;
}

void TCAPS_Client_List::remove_client(struct ip_address * clientip)
{
	std::map<struct ip_address,TCAPS_Client *>::iterator client_iter;
	
	client_list_mutex.acquire();
	
	client_iter = client_list.find(*clientip);
	   				 
	if(client_iter != client_list.end())
	{
		delete ((*client_iter).second);
		client_list.erase(client_iter);
	}
	
	client_list_mutex.release();
}

void TCAPS_Client_List::acquire_mutex()
{
	client_list_mutex.acquire();
}

void TCAPS_Client_List::release_mutex()
{
	client_list_mutex.release();
}

void TCAPS_Client_List::accept(void (*f)(TCAPS_Client *, void *), void * args)
{
	std::map<struct ip_address,TCAPS_Client *>::iterator client_iter;
	
	client_list_mutex.acquire();
	
	for(client_iter = client_list.begin(); client_iter != client_list.end(); client_iter++)
	{
		(*f)(client_iter->second, args);
	}
	
	client_list_mutex.release();
}


bool operator==(const TCAPS_Client_List &f1, const TCAPS_Client_List &f2)
{
//	if(//lists are the same size)
//	{
//		if(each client in the list is same)
//		{
//			return true;
//		}
//	}
	
	return false;
}
