#ifndef _TCAPS_FS_ETHERNET_FRAME_H_
#define _TCAPS_FS_ETHERNET_FRAME_H_

class Ethernet_Frame : public Layer2_Frame
{
public:
	Ethernet_Frame (u8 * frame);
	virtual ~Ethernet_Frame (void);

	virtual unsigned int get_layer2_hdr_len() const;
	virtual unsigned int get_layer2_trailer_len() const;
	u16 get_ethernet_type() const;
	const struct mac_address * get_src_mac_address() const;
	const struct mac_address * get_dst_mac_address() const;
	virtual void to_string(char * buf, unsigned int buflen) const;

private:
	void parse_layer3();
	void parse_ethernet_type();
	void parse_src_mac();
	void parse_dst_mac();
	
protected:
	u16 ethernet_type;
	struct mac_address mac_address_src;
	struct mac_address mac_address_dst;
};

#endif //_TCAPS_FS_ETHERNET_FRAME_H_
