#ifndef _TCAPS_FS_FLOW_ID_H_
#define _TCAPS_FS_FLOW_ID_H_


class TCAPS_Flow_ID
{
public:
	TCAPS_Flow_ID ();
	TCAPS_Flow_ID (const struct ip_address * src_ip, const struct ip_address * dst_ip);
	TCAPS_Flow_ID (u8 fid_type, u8 ipversion, const u8 * bytes);
	TCAPS_Flow_ID (const TCAPS_Flow_ID &);
	virtual ~TCAPS_Flow_ID (void);
	
	const u8 * get_binary_flow_id() const;
	virtual void get_ascii_flow_id(char * buf) const;
	unsigned int get_num_flow_id_bytes() const;
	u8 get_flow_id_type() const;
	u8 get_flow_id_ip_version() const;
	void get_flow_id_srcip(char * buf);
	void get_flow_id_dstip(char * buf);
	struct ip_address * get_flow_id_srcip();
	struct ip_address * get_flow_id_dstip();
	
	TCAPS_Flow_ID & operator=(const TCAPS_Flow_ID &copied_fid);
	TCAPS_Flow_ID * TCAPS_Flow_ID::operator=(const TCAPS_Flow_ID *copied_fid);
	
	friend bool operator<(const TCAPS_Flow_ID &f1, const TCAPS_Flow_ID &f2);
	friend bool operator>(const TCAPS_Flow_ID &f1, const TCAPS_Flow_ID &f2);
	friend bool operator==(const TCAPS_Flow_ID &f1, const TCAPS_Flow_ID &f2);

	
  
protected:
	u8 * flow_id;
	unsigned int num_bytes;
	u8 flow_id_type;
	u8 ip_version;
  
};


//class Flow_ID
//{
//public:
//	Flow_ID ();
//	Flow_ID (u8 * bytes, unsigned int num_b);
//	Flow_ID (u8 * src_ip, u8 * dst_ip, u8 * dst_port, unsigned int ip_size_bytes, unsigned int port_size_bytes);
//	Flow_ID (const Flow_ID &);
//	virtual ~Flow_ID (void);
//	const u8 * get_binary_flow_id() const;
//	void get_ascii_flow_id(char * buf) const;
//	unsigned int get_num_flow_id_bytes() const;
//	
//	bool compare(const Flow_ID &f1, const Flow_ID &f2) const;
//	
//	Flow_ID & operator=(const Flow_ID & copied_flow);
//	
//	friend bool operator<(const Flow_ID &f1, const Flow_ID &f2);
//	friend bool operator>(const Flow_ID &f1, const Flow_ID &f2);
//	friend bool operator==(const Flow_ID &f1, const Flow_ID &f2);
//
//	
//  
//protected:
//	u8 * flow_id;
//	unsigned int num_bytes;
//  
//};


#endif //_TCAPS_FS_FLOW_ID_H_
