#ifndef _TCAPS_FS_FLOW_ID_PORT_H_
#define _TCAPS_FS_FLOW_ID_PORT_H_

class TCAPS_Flow_ID_Port : public TCAPS_Flow_ID
{
public:
	TCAPS_Flow_ID_Port ();
	TCAPS_Flow_ID_Port (const struct ip_address * src_ip, u16 src_port, const struct ip_address * dst_ip, u16 dst_port);
	TCAPS_Flow_ID_Port (u8 fid_type, u8 ipversion, u8 * bytes);
	TCAPS_Flow_ID_Port (const TCAPS_Flow_ID_Port &);
	virtual ~TCAPS_Flow_ID_Port (void);
	
	u16 get_flow_id_src_port() const;
	u16 get_flow_id_dst_port() const;
	virtual void get_ascii_flow_id(char * buf) const;
	
	TCAPS_Flow_ID_Port & operator=(const TCAPS_Flow_ID_Port & copied_fid);

	
  
private:
	u16 src_port;
	u16 dst_port;
};

#endif //_TCAPS_FS_FLOW_ID_PORT_H_
