#ifndef _TCAPS_FS_FLOW_ID_SPI_H_
#define _TCAPS_FS_FLOW_ID_SPI_H_

class TCAPS_Flow_ID_Spi : public TCAPS_Flow_ID
{
public:
	TCAPS_Flow_ID_Spi ();
	TCAPS_Flow_ID_Spi (const struct ip_address * src_ip, u32 src_spi, const struct ip_address * dst_ip, u32 dst_spi);
	TCAPS_Flow_ID_Spi (u8 fid_type, u8 ipversion, u8 * bytes);
	TCAPS_Flow_ID_Spi (const TCAPS_Flow_ID_Spi &);
	virtual ~TCAPS_Flow_ID_Spi (void);
	
	u32 get_flow_id_src_spi() const;
	u32 get_flow_id_dst_spi() const;
	void get_ascii_flow_id(char * buf) const;
	
	TCAPS_Flow_ID_Spi & operator=(const TCAPS_Flow_ID_Spi &copied_fid);

	
  
private:
	u32 src_spi;
	u32 dst_spi;
};

#endif //_TCAPS_FS_FLOW_ID_SPI_H_
