#ifndef _TCAPS_FS_FLOW_MANAGER_TASK_H_
#define _TCAPS_FS_FLOW_MANAGER_TASK_H_

#include <list>
#include <map>
#include "ace/Task.h"



#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */

//struct flow_id_compare
//{
//	bool operator()(const TCAPS_Flow_ID &a, const TCAPS_Flow_ID &b) const
//	{
//		//ACE_DEBUG ((LM_DEBUG, "(%P|%t) TCAPS_Flow_Manager.h in the compare function\n"));
//    	return a < b;
//
//	}
//}; 


/* Like the thread-pool server tutorial, we'll derive from ACE_Task<>.
  Our goal here is to show off the ACE_Message_Queue and the best way
  to do that is to use one to pass data between threads.  The easiest
  way to create threads is with ACE_Task<> */
class TCAPS_Flow_Manager_Task : public ACE_Task <ACE_MT_SYNCH>
{
public:

  typedef ACE_Task <ACE_MT_SYNCH> inherited;

  /* The constructor/destructor are simple but take care of some
    necessary housekeeping.  */
  TCAPS_Flow_Manager_Task (size_t n_threads);
  ~TCAPS_Flow_Manager_Task (void);

  /* open() will kick off our thread pool for us.  */
  int open (void * = 0);

  /* Our worker method */
  int svc (void);

  /* All we'll do here is print a message to the user.  */
  int close (u_long flags = 0);
  
  //std::map<const TCAPS_Flow_ID,TCAPS_Flow *,flowcmp> * get_flows_map();
  
  TCAPS_Client_List * get_client_list();
  
  static void client_list_housekeeping(TCAPS_Client * theclient, void * args);
  static void flow_list_housekeeping(TCAPS_Flow * theflow, void * args);
  

protected:
  //std::list<TCAPS_Rule> rule_list;
  TCAPS_Client_List client_list;
  //std::map <const TCAPS_Flow_ID,TCAPS_Flow *,flowcmp> flows;
  std::list <Pcap_Packet*> unsifted_packets;
  size_t n_threads_;
  // Number of threads in the pool.
};






#endif //_TCAPS_FS_FLOW_MANAGER_TASK_H_
