#ifndef _TCAPS_FS_IPV4_PACKET_H_
#define _TCAPS_FS_IPV4_PACKET_H_

class IPv4_Packet : public Layer3_Packet
{
public:
	IPv4_Packet (u8 * packet);
	virtual ~IPv4_Packet (void);

	virtual unsigned int get_layer3_hdr_len() const;
	virtual void to_string(char * buf, unsigned int buflen) const;
	
	u8 get_protocol() const;
	const struct ip_address * get_src_ip() const;
	const struct ip_address * get_dst_ip() const;
	
private:
	void parse_ipv4_protocol_field();
	void parse_layer4();
	void parse_src_ip();
	void parse_dst_ip();
  
protected:
	u8 protocol;
	struct ip_address ipv4_address_src;
	struct ip_address ipv4_address_dst;
};

#endif //_TCAPS_FS_IPV4_PACKET_H_
