#ifndef _TCAPS_FS_PCAP_PACKET_H_
#define _TCAPS_FS_PCAP_PACKET_H_

#include <arpa/inet.h>

class Pcap_Packet
{
public:
	Pcap_Packet (struct pcap_pkthdr * h, u_char * p);
	Pcap_Packet (const Pcap_Packet & copied_packet);
	virtual ~Pcap_Packet (void);
	
	
	struct pcap_pkthdr * get_pcap_packet_header() const;
	u8 * Pcap_Packet::get_pcap_packet_bytes() const;
	unsigned int Pcap_Packet::get_packet_size() const;
	TCAPS_Flow_ID * get_flow_id();
	unsigned int get_payload_len() const;
	Layer2_Frame * get_layer2_frame() const;
	
	void to_string(char * buf, unsigned int buflen);


private:
	void parse_packet();
	void parse_layer2();
  
protected:
	struct pcap_pkthdr * header;
	unsigned int packet_size;
	u_char * packet;
	
	Layer2_Frame * layer2_frame;
  
};



#endif //_TCAPS_FS_PCAP_PACKET_H_
