#ifndef _TCAPS_FS_SNIFF_TASK_H_
#define _TCAPS_FS_SNIFF_TASK_H_




#include <list>
#include "ace/Task.h"



#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */



/* Like the thread-pool server tutorial, we'll derive from ACE_Task<>.
  Our goal here is to show off the ACE_Message_Queue and the best way
  to do that is to use one to pass data between threads.  The easiest
  way to create threads is with ACE_Task<> */
class TCAPS_Sniff_Task : public ACE_Task <ACE_MT_SYNCH>
{
public:

  typedef ACE_Task <ACE_MT_SYNCH> inherited;

  /* The constructor/destructor are simple but take care of some
    necessary housekeeping.  */
  TCAPS_Sniff_Task (size_t n_threads, pcap_t * s, TCAPS_Flow_Manager_Task * fm_task);
  ~TCAPS_Sniff_Task (void);

  /* open() will kick off our thread pool for us.  */
  int open (void * = 0);

  /* Our worker method */
  int svc (void);

  /* All we'll do here is print a message to the user.  */
  int close (u_long flags = 0);
  
  pcap_t * get_pcap_handle();
  
  TCAPS_Flow_Manager_Task * TCAPS_Sniff_Task::get_flow_manager();

protected:
  //std::list<TCAPS_Rule> rule_list;
  TCAPS_Flow_Manager_Task * flow_manager;
  pcap_t * sniff;
  size_t n_threads_;
  // Number of threads in the pool.
};







#endif //_TCAPS_FS_SNIFF_TASK_H_
