#include "tcaps_fs.h"

TCP_Datagram::TCP_Datagram (u8 * dgram) : Layer4_Datagram(dgram)
{
	#ifdef _PACKET_PARSE_DEBUG_
	ACE_DEBUG ((LM_DEBUG, "(%P|%t) TCP_Datagram ctor 0x%x\n", (void *) this));
	#endif
	
	layer4_protocol = LAYER4_PROTOCOL_TCP;
	layer4_hdr_len = get_layer4_hdr_len();
	//ACE_DEBUG ((LM_DEBUG, "(%P|%t) layer4_hdr_len: %d\n", layer4_hdr_len));

	parse_src_port();
	parse_dst_port();

}

TCP_Datagram::~TCP_Datagram(void)
{
	#ifdef _PACKET_PARSE_DEBUG_
	ACE_DEBUG ((LM_DEBUG, "(%P|%t) TCP_Datagram dtor 0x%x\n", (void *) this));
	#endif
	
}

unsigned int TCP_Datagram::get_layer4_hdr_len() const
{
	return (((*(layer4_dgram+(TCAPS_SP_TCPHDR_OFFSET_OFFSET/8)))&0xf0)>>4)*4;
}

u16 TCP_Datagram::get_src_port() const
{
	return tcp_port_src;
}

u16 TCP_Datagram::get_dst_port() const
{
	return tcp_port_dst;
}

void TCP_Datagram::parse_src_port()
{
	tcp_port_src = ntohs(*((u16 *)(layer4_dgram+(TCAPS_SP_TCPHDR_SRCPORT_OFFSET/8))));
}

void TCP_Datagram::parse_dst_port()
{
	tcp_port_dst = ntohs(*((u16 *)(layer4_dgram+(TCAPS_SP_TCPHDR_DSTPORT_OFFSET/8))));
}

void TCP_Datagram::to_string(char * buf, unsigned int buflen) const
{

	snprintf(buf,
			 buflen,
			 "layer4_protocol: TCP\nlayer4_hdr_len: %d\nsrc_port: %u\ndst_port: %u\n",
			 layer4_hdr_len,
			 tcp_port_src,
			 tcp_port_dst);
			 
}
