#include "tcaps_fs.h"

UDP_Datagram::UDP_Datagram (u8 * dgram) : Layer4_Datagram(dgram)
{
	#ifdef _PACKET_PARSE_DEBUG_
	ACE_DEBUG ((LM_DEBUG, "(%P|%t) UDP_Datagram ctor 0x%x\n", (void *) this));
	#endif
	
	layer4_protocol = LAYER4_PROTOCOL_UDP;
	layer4_hdr_len = get_layer4_hdr_len();

	parse_src_port();
	parse_dst_port();

}

UDP_Datagram::~UDP_Datagram(void)
{
	#ifdef _PACKET_PARSE_DEBUG_
	ACE_DEBUG ((LM_DEBUG, "(%P|%t) UDP_Datagram dtor 0x%x\n", (void *) this));
	#endif
	
}


unsigned int UDP_Datagram::get_layer4_hdr_len() const
{
	return 8;
}

u16 UDP_Datagram::get_src_port() const
{
	return udp_port_src;
}

u16 UDP_Datagram::get_dst_port() const
{
	return udp_port_dst;
}
	

void UDP_Datagram::parse_src_port()
{
	udp_port_src = *((u16 *)(layer4_dgram+(TCAPS_SP_UDPHDR_SRCPORT_OFFSET/8)));
}

void UDP_Datagram::parse_dst_port()
{
	udp_port_dst = *((u16 *)(layer4_dgram+(TCAPS_SP_UDPHDR_DSTPORT_OFFSET/8)));
}

void UDP_Datagram::to_string(char * buf, unsigned int buflen) const
{

	snprintf(buf,
			 buflen,
			 "layer4_protocol: UDP\nlayer4_hdr_len: %d\nsrc_port: %u\ndst_port: %u\n",
			 layer4_hdr_len,
			 udp_port_src,
			 udp_port_dst);
			 
}
