#ifndef _TCAPS_MANAGER_CLIENT_H_
#define _TCAPS_MANAGER_CLIENT_H_


class TCAPS_Client
{
public:
	TCAPS_Client ();
	TCAPS_Client (struct mac_address * mac);
	TCAPS_Client (struct mac_address * mac, struct ip_address * ip, u16 port);
	TCAPS_Client (const TCAPS_Client &copied_client);
	virtual ~TCAPS_Client (void);
	
	u16 get_client_port() const;
	struct ip_address get_client_ip() const;
	struct ip_address get_fs_ip() const;
	struct mac_address get_client_mac() const;
	void to_string(char * buf, unsigned int bufsize) const;
	TCAPS_Rule_List * get_client_rules() const;
	unsigned int get_last_poll_time() const;


	void set_last_poll_time(unsigned int time);
	void set_client_port(u16 port);
	void set_client_ip(const struct ip_address * ip);
	void set_fs_ip(const struct ip_address * ip);
	
	TCAPS_Client & operator=(const TCAPS_Client &copied_client);
	
	friend bool operator<(const TCAPS_Client &f1, const TCAPS_Client &f2);
	friend bool operator>(const TCAPS_Client &f1, const TCAPS_Client &f2);
	friend bool operator==(const TCAPS_Client &f1, const TCAPS_Client &f2);

	
  
private:
	struct mac_address client_mac;
	struct ip_address client_ip;
	struct ip_address fs_ip;
	u16 client_port;
	unsigned int last_poll_time;
	
	TCAPS_Rule_List * client_rules;
  
};


#endif //_TCAPS_MANAGER_CLIENT_H_
