#ifndef _TCAPS_MANAGER_CLIENT_MANAGER_TASK_H_
#define _TCAPS_MANAGER_CLIENT_MANAGER_TASK_H_

#include "ace/Task.h"

#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */

/* Like the thread-pool server tutorial, we'll derive from ACE_Task<>.
  Our goal here is to show off the ACE_Message_Queue and the best way
  to do that is to use one to pass data between threads.  The easiest
  way to create threads is with ACE_Task<> */
class TCAPS_Client_Manager_Task : public ACE_Task <ACE_MT_SYNCH>
{
public:

	typedef ACE_Task <ACE_MT_SYNCH> inherited;

	TCAPS_Client_Manager_Task(TCAPS_Network_Task * ci_comms, TCAPS_Network_Task * fs_comms);
	~TCAPS_Client_Manager_Task(void);

	int open (void * = 0);
	int svc (void);
	int close (u_long flags = 0);
  
	TCAPS_Client_List * get_client_list();
  
private:
	void perform_housekeeping();
	void handle_packets();
	struct tcaps_sp_packet * receive_packet(ACE_INET_Addr * remote);
	void handle_pp_packet(struct tcaps_sp_pp * packet, ACE_INET_Addr * remote);
	void handle_crmp_packet(struct tcaps_sp_crmp * packet, ACE_INET_Addr * remote);
	void send_cmp(u8 cmp_op_type, TCAPS_Client * theclient);
	void send_rmp(TCAPS_Rule * therule, TCAPS_Client * theclient);
	
protected:
	TCAPS_Client_List client_list;
	TCAPS_Network_Task * ci_comms_task;
	TCAPS_Network_Task * fs_comms_task;
	size_t n_threads_;
};

#endif //_TCAPS_MANAGER_CLIENT_MANAGER_TASK_H_
