#ifndef _TCAPS_MANAGER_NETWORK_TASK_H_
#define _TCAPS_MANAGER_NETWORK_TASK_H_


#include "ace/Task.h"

#if !defined (ACE_LACKS_PRAGMA_ONCE)
# pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */



class TCAPS_Network_Task : public ACE_Task <ACE_MT_SYNCH>
{
public:

	typedef ACE_Task <ACE_MT_SYNCH> inherited;

	TCAPS_Network_Task (ACE_SOCK_Dgram * udpsock);
	~TCAPS_Network_Task (void);
  
	int open (void * = 0);
	int svc (void);
	int close (u_long flags = 0);
  
	void send_packet(Packet_Block * tosend);
	Packet_Block * receive_packet();

private:

	Packet_Block * handle_received_packet(struct tcaps_sp_packet * packet, ACE_INET_Addr * remote);
	
protected:
	ACE_Message_Queue<ACE_MT_SYNCH> inbound;
	ACE_Message_Queue<ACE_MT_SYNCH> outbound;
	ACE_SOCK_Dgram * udp_socket;
	size_t n_threads_;
};


#endif //_TCAPS_MANAGER_NETWORK_TASK_H_
