#ifndef _TCAPS_MANAGER_RULE_H_
#define _TCAPS_MANAGER_RULE_H_

class TCAPS_Rule
{
public:
	TCAPS_Rule ();
	TCAPS_Rule (struct tcaps_sp_rmp * rule_pack);
	TCAPS_Rule (const TCAPS_Rule &);
	virtual ~TCAPS_Rule (void);

	u16 get_rule_num() const;
	const struct tcaps_sp_rmp * get_rmp() const;
	const u8 * get_serialized() const;
	unsigned int get_serialized_bytes() const;
	void to_string(char * buf, unsigned int bufsize) const;
	unsigned int get_expiry_time() const;
	
	void set_op_type(u8 type);
	void set_identifier(struct mac_address * mac);
	void set_timeout(u16 timeout);
	void set_rule_num(u16 rulenum);
	void set_expiry_time(unsigned int time);
	
	TCAPS_Rule & operator=(const TCAPS_Rule &copied_rule);
	
	friend bool operator==(const TCAPS_Rule &r1, const TCAPS_Rule &r2);

	
  
private:
	struct tcaps_sp_rmp * rule;
	unsigned int expiry_time_secs;

};

#endif //_TCAPS_MANAGER_RULE_H_
