#ifndef _TCAPS_MANAGER_RULE_LIST_H_
#define _TCAPS_MANAGER_RULE_LIST_H_


#include <map>

#include "ace/Synch.h"

typedef ACE_Thread_Mutex mutex_t;
typedef std::pair<u16,TCAPS_Rule *> rule_entry;

//struct rulecmp
//{
//	bool operator()(const TCAPS_Flow_ID &a, const TCAPS_Flow_ID &b) const
//	{
//		//ACE_DEBUG ((LM_DEBUG, "(%P|%t) TCAPS_Flow_List.h in the compare function\n"));
//		
//		if(a.get_flow_id_type() == b.get_flow_id_type())
//		{
//			return (a < b);
//		}
//		
//		return (a.get_flow_id_type() < b.get_flow_id_type()); //IPIP flows < IPIPPORT flows < IPIPSPI flows
//
//	}
//}; 

class TCAPS_Rule_List
{
public:
	TCAPS_Rule_List ();
	TCAPS_Rule_List (const TCAPS_Rule_List &);
	virtual ~TCAPS_Rule_List (void);

	std::map<u16,TCAPS_Rule *> get_rule_list() const;
	void add_rule(TCAPS_Rule * therule);
	bool find_rule(u16 rulenum);
	TCAPS_Rule * get_rule(u16 rulenum);
	TCAPS_Rule * get_rule(const struct tcaps_sp_rmp * rule_pack);
	void acquire_mutex();
	void release_mutex();
	u16 get_next_rule_num() const;
	void remove_rule(u16 rulenum);
	
	TCAPS_Rule_List & operator=(const TCAPS_Rule_List &copied_rule_list);
	
	friend bool operator==(const TCAPS_Rule_List &f1, const TCAPS_Rule_List &f2);

	
  
private:
	mutex_t rule_list_mutex;
	std::map<u16,TCAPS_Rule *> rule_list;
	u16 next_rule_num;

};


#endif //_TCAPS_MANAGER_RULE_LIST_H_
