#ifndef _TCAPS_PF_TRANSLATOR_H_
#define _TCAPS_PF_TRANSLATOR_H_



#include <sys/param.h>
#include <sys/linker.h>
#include <errno.h>

#include <unistd.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <fcntl.h>

//#include <net/if.h>
//#include <netinet/in.h>
//#include <net/pfvar.h>
#include <stdio.h>
#include <stdlib.h>




#define TCAPS_PF_KERNEL_MODULE						"pf.ko"

#define TCAPS_PF_DEFAULT_PFCTL_PATH					"/sbin/pfctl\0"
#define TCAPS_PF_DEFAULT_RC_FILE					"/etc/pf.conf\0"
#define TCAPS_PF_DEFAULT_RC_TEMP_FILE				"/etc/pf.conf~\0"
#define TCAPS_PF_DEFAULT_PF_DEV						"/dev/pf\0"

#define TCAPS_PF_RC_FILE_STATIC_MARKER				"#tcaps_static_begin"
#define TCAPS_PF_RC_FILE_DYNAMIC_MARKER				"#tcaps_dynamic_begin"

#define TCAPS_PF_TRANSLATOR_MAX_PRIQS				16

#define TCAPS_PF_TRANSLATOR_RULESEG_TYPE_UNKNOWN	0
#define TCAPS_PF_TRANSLATOR_RULESEG_TYPE_SRCIP		1
#define TCAPS_PF_TRANSLATOR_RULESEG_TYPE_DSTIP		2
#define TCAPS_PF_TRANSLATOR_RULESEG_TYPE_SRCPORT	3
#define TCAPS_PF_TRANSLATOR_RULESEG_TYPE_DSTPORT	4


void tcaps_translate_rmp2pf(const struct tcaps_sp_rmp * packet, char * interface, char * command);
void translate_rule_segments(const LINKEDLIST * rule_segs, char * command);
void translate_rule_segment(const struct tcaps_sp_rule_segment * rule_seg, char * buf, unsigned int bufsize, unsigned int * ruleseg_type);
void parse_ipv4_address(u8 * ref_bit_sequence, u16 num_bits_to_match, char * buf, unsigned int bufsize);
void parse_port(u8 * ref_bit_sequence, u16 num_bits_to_match, char * buf, unsigned int bufsize);
void assemble_rule(char ** parsed_rulesegs, unsigned int bufsize, unsigned int * parsed_ruleseg_types, unsigned int num_rulesegs, char * command);
int tcaps_pf_init(char * interface);
int tcaps_pf_init_rc_file(char * pf_rc_file, char * interface);
boolean tcaps_pf_check_rc_file(FILE * rc_file);
int tcaps_pf_add_rule(const char * rule_command, const char * interface);
boolean fexists(char * filename);
void tcaps_pf_shutdown();
int tcaps_pf_delete_rule(const char * command, const char * interface);


#endif //_TCAPS_PF_TRANSLATOR_H_
