#include "tcaps_qosss_translator.h"

#define __FREEBSD__

unsigned int tcaps_qosss_init(char * interface)
{

	#ifdef TCAPS_QOSSS_PFALTQ
		
		return tcaps_pf_init(interface);
		
//	#else
//	#ifdef TCAPS_QOSSS_TC
//	
//		return tcaps_tc_init();
		
	#endif
	
}

void tcaps_translate_rmp2qosss(const struct tcaps_sp_rmp * packet, char * interface, char * rule_command, int rule_number)
{
	#ifdef TCAPS_QOSSS_PFALTQ
		
		tcaps_translate_rmp2pf(packet, interface, rule_command);
		
//	#else
//	#ifdef TCAPS_QOSSS_TC
//	
//		return tcaps_tc_init();
		
	#endif
	
}

void tcaps_qosss_add_rule(const char * rule_command, const char * interface)
{
	#ifdef TCAPS_QOSSS_PFALTQ
		
		tcaps_pf_add_rule(rule_command, interface);
		
//	#else
//	#ifdef TCAPS_QOSSS_TC
//	
//		return tcaps_tc_init();
		
	#endif
}

int tcaps_qosss_delete_rule(const char * rule_command, const char * interface)
{
	#ifdef TCAPS_QOSSS_PFALTQ
		
		return tcaps_pf_delete_rule(rule_command, interface);
		
//	#else
//	#ifdef TCAPS_QOSSS_TC
//	
//		return tcaps_tc_init();
		
	#endif
}


void tcaps_qosss_shutdown()
{
	#ifdef TCAPS_QOSSS_PFALTQ
		
		tcaps_pf_shutdown();
		
//	#else
//	#ifdef TCAPS_QOSSS_TC
//	
//		return tcaps_tc_init();
		
	#endif
}
	
