#ifndef _TCAPS_QOSSS_TRANSLATOR_H_
#define _TCAPS_QOSSS_TRANSLATOR_H_


//This define is just simulating someone defining it on the command line during the make process
#define TCAPS_QOSSS_PFALTQ



#include <structureslib_libs.h>
#include <tcaps_sp.h>

#ifdef __cplusplus
extern "C" {
#endif


void tcaps_translate_rmp2qosss(const struct tcaps_sp_rmp * packet, char * interface, char * command, int rule_number);

void tcaps_translate_qosss2rmp(const char * command, struct tcaps_sp_rmp * packet);

void tcaps_translate_qosss_feedback(char * feedback, int * error_code);

unsigned int tcaps_qosss_init(char * interface);

void tcaps_qosss_add_rule(const char * rule_command, const char * interface);

void tcaps_qosss_shutdown();

int tcaps_qosss_delete_rule(const char * rule_command, const char * interface);

#ifdef TCAPS_QOSSS_PFALTQ
	#include "tcaps_pf_translator.h"
#endif



#ifdef __cplusplus
}
#endif


#endif //_TCAPS_QOSSS_TRANSLATOR_H_
