#include "tcaps_sp.h"

void tcaps_sp_parse_packet(u8 * recv_packet, unsigned int packet_len, struct tcaps_sp_packet * packet)
{
	//printf("The packet type pulled form the packet is: %d\n", *(recv_packet+TCAPS_SP_PACKET_TYPE_OFFSET));

	switch(*(recv_packet+TCAPS_SP_PACKET_TYPE_OFFSET))
	{
		case TCAPS_RMP_PACKET_TYPE:
				packet->packet = tcaps_sp_rmp_parse_packet(recv_packet, packet_len);
				if (NULL == packet->packet)
					packet->packet_type = TCAPS_NULL_PACKET_TYPE;
				else
					packet->packet_type = TCAPS_RMP_PACKET_TYPE;
			break;
		case TCAPS_AP_PACKET_TYPE:
				packet->packet = tcaps_sp_ap_parse_packet(recv_packet, packet_len);
				if (NULL == packet->packet)
					packet->packet_type = TCAPS_NULL_PACKET_TYPE;
				else
					packet->packet_type = TCAPS_AP_PACKET_TYPE;
			break;
		case TCAPS_TP_PACKET_TYPE:
				packet->packet = tcaps_sp_tp_parse_packet(recv_packet, packet_len);
				if (NULL == packet->packet)
					packet->packet_type = TCAPS_NULL_PACKET_TYPE;
				else
					packet->packet_type = TCAPS_TP_PACKET_TYPE;
			break;
		case TCAPS_PP_PACKET_TYPE:
				packet->packet = tcaps_sp_pp_parse_packet(recv_packet, packet_len);
				if (NULL == packet->packet)
					packet->packet_type = TCAPS_NULL_PACKET_TYPE;
				else
					packet->packet_type = TCAPS_PP_PACKET_TYPE;
			break;
		case TCAPS_FFP_PACKET_TYPE:
				packet->packet = tcaps_sp_ffp_parse_packet(recv_packet, packet_len);
				if (NULL == packet->packet)
					packet->packet_type = TCAPS_NULL_PACKET_TYPE;
				else
					packet->packet_type = TCAPS_FFP_PACKET_TYPE;
			break;
		case TCAPS_CRMP_PACKET_TYPE:
				packet->packet = tcaps_sp_crmp_parse_packet(recv_packet, packet_len);
				if (NULL == packet->packet)
					packet->packet_type = TCAPS_NULL_PACKET_TYPE;
				else
					packet->packet_type = TCAPS_CRMP_PACKET_TYPE;
			break;
		case TCAPS_CMP_PACKET_TYPE:
				packet->packet = tcaps_sp_cmp_parse_packet(recv_packet, packet_len);
				if (NULL == packet->packet)
					packet->packet_type = TCAPS_NULL_PACKET_TYPE;
				else
					packet->packet_type = TCAPS_CMP_PACKET_TYPE;
			break;
		default:
			//we weren't passed a valid TCAPS packet
			packet->packet_type = TCAPS_NULL_PACKET_TYPE;
			break;
	}

	//return TCAPS_SP_INFO_CODE;
}
